/* ---------------------------------------------------------------------
     Small Music Information Retrieval Toolkit

    Copyright (c) 2008 Rebecca Fiebrink, Ge Wang and Perry R. Cook.  
    All rights reserved.
       http://smirk.cs.princeton.edu/
       http://chuck.cs.princeton.edu
       http://soundlab.cs.princeton.edu/

    Portions of SMIRK are based on the design of the Weka data mining
    toolkit, a GPL package.
       http://www.cs.waikato.ac.nz/ml/weka/
       Ian H. Witten and Eibe Frank (2005) "Data Mining: 
       Practical machine learning tools and techniques", 2nd Edition, 	
       Morgan Kaufmann, San Francisco, 2005.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A. 
--------------------------------------------------------------------- */
/**
	Some simple code that shows how AdaBoost works
*/

//Test out decision stump
//Play around with changing classes, values, and weights

Instance i1, i2, i3, i4, i5, i6;
Instances is;

//Construct some instances
[0., 2., -2.] @=> i1.m_fv;
[1., 3., 4.] @=> i2.m_fv;
[2., 4., 1.1] @=> i3.m_fv;
[3., 0., 10.] @=> i4.m_fv;
[4., -1., 20.] @=> i5.m_fv;
[5., 1., 15.] @=> i6.m_fv;

//Assign them classes
-1 => i1.m_class;
-1 => i2.m_class;
1 => i3.m_class;
2 => i4.m_class;
2 => i5.m_class;
2 => i6.m_class;

is.add(i1);
is.add(i2);
is.add(i3);
is.add(i4);
is.add(i5);

AdaBoostM1 ab;
//Pass the instances to the classifier as its training set
is => ab.set_instances;
//Set the number of boosting rounds
20 => ab.set_num_rounds;
//Show the progress of the classifier to watch the training converge
1 => ab.show_progress;
//Execute the training step
ab.train();

//Test the classifier on the output
<<< "Prediction: ", ab.classify(i6), " correct? ", ab.test(i6) >>>;