/* ---------------------------------------------------------------------
     Small Music Information Retrieval Toolkit

    Copyright (c) 2008 Rebecca Fiebrink, Ge Wang and Perry R. Cook.  
    All rights reserved.
       http://smirk.cs.princeton.edu/
       http://chuck.cs.princeton.edu
       http://soundlab.cs.princeton.edu/

    Portions of SMIRK are based on the design of the Weka data mining
    toolkit, a GPL package.
       http://www.cs.waikato.ac.nz/ml/weka/
       Ian H. Witten and Eibe Frank (2005) "Data Mining: 
       Practical machine learning tools and techniques", 2nd Edition, 	
       Morgan Kaufmann, San Francisco, 2005.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A. 
--------------------------------------------------------------------- */
/**
	Simple tester for decision stumps
	Try playing around with changing features, classes, and weights!
*/
Instance i1, i2, i3, i4, i5, i6;
Instances is;

[1., 0.0, 1.0] @=> i1.m_fv;
[1., 1.0, 1.0] @=> i2.m_fv;
[1., 2.0, 1.0] @=> i3.m_fv;
[1., 3.0, 1.0] @=> i4.m_fv;
[1., 4.0, 1.0] @=> i5.m_fv;

-1 => i1.m_class;
-1 => i2.m_class;
-1 => i3.m_class;
1 => i4.m_class;
2 => i5.m_class;

1 => i1.m_weight;
1 => i2.m_weight;
1 => i3.m_weight;
1 => i4.m_weight;
1.1 => i5.m_weight;

new DecisionStump @=> DecisionStump ds;

is.add(i1);
is.add(i2);
is.add(i3);
is.add(i4);
is.add(i5);

ds.set_instances(is);
ds.train();
ds.print_probs(is);

//Print out a description of what was learned
<<< "FEATURE:", ds.m_AttIndex, " SPLIT:",ds.m_SplitPoint >>>;

//Classify a new instance
[1., 4.0, 1.0] @=> i6.m_fv;
2 => i6.m_class;
<<< "CLASS: ", ds.classify(i6), " correct? ", ds.test(i6) >>>;
