/* ---------------------------------------------------------------------
     Small Music Information Retrieval Toolkit

    Copyright (c) 2008 Rebecca Fiebrink, Ge Wang and Perry R. Cook.  
    All rights reserved.
       http://smirk.cs.princeton.edu/
       http://chuck.cs.princeton.edu
       http://soundlab.cs.princeton.edu/

    Portions of SMIRK are based on the design of the Weka data mining
    toolkit, a GPL package.
       http://www.cs.waikato.ac.nz/ml/weka/
       Ian H. Witten and Eibe Frank (2005) "Data Mining: 
       Practical machine learning tools and techniques", 2nd Edition, 	
       Morgan Kaufmann, San Francisco, 2005.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A. 
--------------------------------------------------------------------- */

/**
	Classifier: Base class for classifiers
*/
public class Classifier
{
	//An internal record of the training set
    new Instances @=> Instances m_instances;
    
	fun void set_instances(Instances i) {
		i @=> m_instances;
	}

	//Add an instance to the training set
    fun void add_instance(Instance i) {
        m_instances.add(i);
    }

	fun void train() {
		//Classifier specific
	}

	//Test classifier on an instance
	//Returns 1 for correct, 0 for incorrect
	fun int test(Instance tester) {
        classify(tester) => int result;
		if (result == tester.m_class) {
			return 1;
		} else {
			return 0;
		}
    }

	//Classify an instance
	//Return the class predicted by the classifier
	fun int classify(Instance tester) {
		return 0;
	}
    
	//Clear training set
    fun void clear() {
        new Instances @=> m_instances;
    }
    
}