/* ---------------------------------------------------------------------
     Small Music Information Retrieval Toolkit

    Copyright (c) 2008 Rebecca Fiebrink, Ge Wang and Perry R. Cook.  
    All rights reserved.
       http://smirk.cs.princeton.edu/
       http://chuck.cs.princeton.edu
       http://soundlab.cs.princeton.edu/

    Portions of SMIRK are based on the design of the Weka data mining
    toolkit, a GPL package.
       http://www.cs.waikato.ac.nz/ml/weka/
       Ian H. Witten and Eibe Frank (2005) "Data Mining: 
       Practical machine learning tools and techniques", 2nd Edition, 	
       Morgan Kaufmann, San Francisco, 2005.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A. 
--------------------------------------------------------------------- */

/**
	Instance: A feature vector with an integer class value
*/
public class Instance
{
	//Indicates the class value
    0 => int m_class; 

	//The weight of this instance
	// used for boosting
	1. => float m_weight;

	//The feature vector
	//Currently only float features allowed
    float m_fv[];
    
	//Print the feature vector, class, and weight
    fun void print() {
        for (0 => int i; i < m_fv.size(); i++) {
            <<< m_fv[i] >>>;
        }
        <<< "class: ", m_class, "weight: ", m_weight >>>;
    }

	//The length of the feature vector, not including class
	fun int num_feats() {
		return m_fv.size();
	}

	//Create a deep copy of this instance
	fun Instance copy() {
		new Instance @=> Instance n;
		m_class => n.m_class;
		m_weight => n.m_weight;
		new float[m_fv.size()] @=> n.m_fv;
		for (0 => int i; i < m_fv.size(); i++) {
			m_fv[i] => n.m_fv[i];
		}
	}
}