/* ---------------------------------------------------------------------
     Small Music Information Retrieval Toolkit

    Copyright (c) 2008 Rebecca Fiebrink, Ge Wang and Perry R. Cook.  
    All rights reserved.
       http://smirk.cs.princeton.edu/
       http://chuck.cs.princeton.edu
       http://soundlab.cs.princeton.edu/

    Portions of SMIRK are based on the design of the Weka data mining
    toolkit, a GPL package.
       http://www.cs.waikato.ac.nz/ml/weka/
       Ian H. Witten and Eibe Frank (2005) "Data Mining: 
       Practical machine learning tools and techniques", 2nd Edition, 	
       Morgan Kaufmann, San Francisco, 2005.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A. 
--------------------------------------------------------------------- */

/** 
	This is a simple script for testing kNN and verifying that it works as expected.
	Try playing with varying the number of features, classes, neighbors, etc.
*/

Instance i1, i2, i3, i4;

[1., 1., 1., 1.] @=> i1.m_fv;
0 => i1.m_class;

[1., 0., 0., 1.] @=> i2.m_fv;
1 => i2.m_class;

[1., .02, .02, 2.] @=> i3.m_fv;
2 => i3.m_class;

new kNN @=> kNN k;

1 => k.m_num_neighbors;

/* Alternative 1:
k.add_instance(i1);
k.add_instance(i2);
k.add_instance(i3);
*/

//Alternative 2: (equivalent)
new Instances @=> Instances i;
i.add(i1);
i.add(i2);
i.add(i3);
k.set_instances(i);

//add a testing instance
[1., 0., 0., 2.] @=> i4.m_fv;
1 => i4.m_class;

<<< "Result: ", k.classify(i4), " correct? ", k.test(i4) >>>;
